#ifndef PREFS_H
#define PREFS_H

// prefs.h by Matt Ownby

#include "transfers.h"	// this includes everything we need (main.h and wx stuff)

// will display stats about the transfer
class GUIPrefs: public wxDialog
{
public:
	GUIPrefs(wxWindow *parent);
	void OnClose(wxCommandEvent& event);
	void OnApply(wxCommandEvent& event);

	DECLARE_EVENT_TABLE()

private:

	// helper function to do mass adds of text to m_gsizer
	void AddTextFlex(wxStaticText **txt, const char *s);

	// helper function to do mass input box adding to m_gsizer
	void AddInputFlex(wxTextCtrl **inp, const char *s);
		
	// updates values of our controls/widgets with current values (does not modify any current values)
	void refresh_controls();

	void refresh_helper(unsigned int val, wxStaticText *lbl, wxTextCtrl *txt, bool xfer);
	
	// modifies current values in memory with values from the widgets (unless widget value is invalid)
	void apply_changes();

	wxPanel *m_panel;
	wxFlexGridSizer *m_gsizer;
	wxBoxSizer *m_btnsizer;	// horizontal button sizer
	wxBoxSizer *m_vsizer;

	wxStaticText *m_lblMaxUlBytes;
	wxStaticText *m_lblMaxDlBytes;
	wxStaticText *m_lblLeechRes;
	wxStaticText *m_lblMaxPeers;
	wxStaticText *m_lblListenPort;

	wxTextCtrl *m_txtMaxUlBytes;
	wxTextCtrl *m_txtMaxDlBytes;
	wxChoice *m_lstLeechRes;
	wxTextCtrl *m_txtMaxPeers;
	wxTextCtrl *m_txtListenPort;
	
	wxButton *m_btnApply, *m_btnClose;

};


#endif // PREFS_H
